Index: /XIOS/trunk/src/attribute_map.cpp
===================================================================
--- /XIOS/trunk/src/attribute_map.cpp	(revision 965)
+++ /XIOS/trunk/src/attribute_map.cpp	(revision 966)
@@ -629,5 +629,6 @@
 
          oss << std::endl << iendl;
-         oss << "CALL xios(get_" << className << "_handle)(" << className << "_id," << className << "_hdl)" << iendl;
+         oss << "CALL xios(get_" << className << "_handle) &" << iendl;
+         oss << "(" << className << "_id," << className << "_hdl)" << iendl;
          oss << "CALL xios(set_" << className << "_attr_hdl_)   &" << iendl;
 
@@ -693,5 +694,6 @@
 
          oss << std::endl << iendl;
-         oss << "CALL xios(get_" << className << "_handle)(" << className << "_id," << className << "_hdl)" << iendl;
+         oss << "CALL xios(get_" << className << "_handle) &" << iendl;
+         oss << "(" << className << "_id," << className << "_hdl)" << iendl;
          oss << "CALL xios(get_" << className << "_attr_hdl_)   &" << iendl;
 
@@ -757,5 +759,6 @@
 
          oss << std::endl << iendl;
-         oss << "CALL xios(get_" << className << "_handle)(" << className << "_id," << className << "_hdl)" << iendl;
+         oss << "CALL xios(get_" << className << "_handle) &" << iendl;
+         oss << "(" << className << "_id," << className << "_hdl)" << iendl;
          oss << "CALL xios(is_defined_" << className << "_attr_hdl_)   &" << iendl;
 
Index: /XIOS/trunk/src/generate_interface_impl.hpp
===================================================================
--- /XIOS/trunk/src/generate_interface_impl.hpp	(revision 965)
+++ /XIOS/trunk/src/generate_interface_impl.hpp	(revision 966)
@@ -323,7 +323,9 @@
     {
       oss << "  " << name_tmp << " = " << name << "_" << iendl;
-      oss << "  CALL cxios_set_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name_tmp << ")" << iendl;
+      oss << "  CALL cxios_set_" << className << "_" << name << " &" << iendl;
+      oss << "(" << className << "_hdl%daddr, " << name_tmp << ")" << iendl;
     }
-    else oss << "  CALL cxios_set_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name << "_)" << iendl;
+    else { oss << "  CALL cxios_set_" << className << "_" << name << " &" << iendl;
+           oss << "(" << className << "_hdl%daddr, " << name << "_)" << iendl; }
     oss << "ENDIF";
   }
@@ -337,8 +339,10 @@
     if (!matchingTypeCFortran<T>())
     {
-      oss << "  CALL cxios_get_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name_tmp << ")" << iendl;
+      oss << "  CALL cxios_get_" << className << "_" << name << " &" << iendl;
+      oss << "(" << className << "_hdl%daddr, " << name_tmp << ")" << iendl;
       oss << "  " << name << "_ = " << name_tmp << iendl;
     }
-    else oss << "  CALL cxios_get_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name << "_)" << iendl;
+    else { oss << "  CALL cxios_get_" << className << "_" << name << " &" << iendl;
+           oss << "(" << className << "_hdl%daddr, " << name << "_)" << iendl; }
     oss << "ENDIF";
   }
@@ -349,5 +353,6 @@
 
     oss << "IF (PRESENT(" << name << "_)) THEN" << iendl;
-    oss << "  " << name << "__tmp = cxios_is_defined_" << className << "_" << name << "(" << className << "_hdl%daddr)" << iendl;
+    oss << "  " << name << "__tmp = cxios_is_defined_" << className << "_" << name << " &" << iendl;
+    oss << "(" << className << "_hdl%daddr)" << iendl;
     oss << "  " << name << "_ = " << name_tmp << iendl;
     oss << "ENDIF";
@@ -358,5 +363,6 @@
   {
     oss << "IF (PRESENT(" << name << "_)) THEN" << iendl;
-    oss << "  CALL cxios_set_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name << "_, len(" << name << "_))" << iendl;
+    oss << "  CALL cxios_set_" << className << "_" << name << " &" << iendl;
+    oss << "(" << className << "_hdl%daddr, " << name << "_, len(" << name << "_))" << iendl;
     oss << "ENDIF";
   }
@@ -366,5 +372,6 @@
   {
     oss << "IF (PRESENT(" << name << "_)) THEN" << iendl;
-    oss << "  CALL cxios_get_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name << "_, len(" << name << "_))" << iendl;
+    oss << "  CALL cxios_get_" << className << "_" << name << " &" << iendl;
+    oss << "(" << className << "_hdl%daddr, " << name << "_, len(" << name << "_))" << iendl;
     oss << "ENDIF";
   }
@@ -813,7 +820,9 @@
       oss << "  ALLOCATE(" << name_tmp << "(SIZE(" << name << "_,1)))" << iendl; \
       oss << "  " << name_tmp << " = " << name << "_" << iendl; \
-      oss << "  CALL cxios_set_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
+      oss << "  CALL cxios_set_" << className << "_" << name << " &" << iendl; \
+      oss << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
     } \
-    else oss << "  CALL cxios_set_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; \
+    else { oss << "  CALL cxios_set_" << className << "_" << name << " &" << iendl; \
+           oss << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; } \
     oss << "ENDIF"; \
   } \
@@ -829,7 +838,9 @@
       oss << "  ALLOCATE(" << name_tmp << "(SIZE(" << name << "_,1), SIZE(" << name << "_,2)))" << iendl; \
       oss << "  " << name_tmp << " = " << name << "_" << iendl; \
-      oss << "  CALL cxios_set_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
+      oss << "  CALL cxios_set_" << className << "_" << name << " &" << iendl; \
+      oss << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
     } \
-    else oss << "  CALL cxios_set_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; \
+    else { oss << "  CALL cxios_set_" << className << "_" << name << " &" << iendl; \
+           oss << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; } \
     oss << "ENDIF"; \
   } \
@@ -845,7 +856,9 @@
       oss << "  ALLOCATE(" << name_tmp << "(SIZE(" << name << "_,1), SIZE(" << name << "_,2), SIZE(" << name << "_,3)))" << iendl; \
       oss << "  " << name_tmp << " = " << name << "_" << iendl; \
-      oss << "  CALL cxios_set_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
+      oss << "  CALL cxios_set_" << className << "_" << name << " &" << iendl; \
+      oss << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
     } \
-    else oss << "  CALL cxios_set_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; \
+    else { oss << "  CALL cxios_set_" << className << "_" << name << " &" << iendl; \
+           oss << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; } \
     oss << "ENDIF"; \
   }\
@@ -859,9 +872,12 @@
     if (!matchingTypeCFortran<T>())  \
     { \
-      oss << "  ALLOCATE(" << name_tmp << "(SIZE(" << name << "_,1), SIZE(" << name << "_,2), SIZE(" << name << "_,3), SIZE(" << name << "_,4)))" << iendl; \
+      oss << "  ALLOCATE(" << name_tmp << "(SIZE(" << name << "_,1), SIZE(" << name << "_,2), SIZE(" << name << "_,3), &" << iendl; \
+      oss << " SIZE(" << name << "_,4)))" << iendl; \
       oss << "  " << name_tmp << " = " << name << "_" << iendl; \
-      oss << "  CALL cxios_set_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
+      oss << "  CALL cxios_set_" << className << "_" << name << " &" << iendl; \
+      oss << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
     } \
-    else oss << "  CALL cxios_set_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; \
+    else { oss << "  CALL cxios_set_" << className << "_" << name << " &" << iendl; \
+           oss << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; } \
     oss << "ENDIF"; \
   }\
@@ -875,9 +891,12 @@
     if (!matchingTypeCFortran<T>())  \
     { \
-      oss << "  ALLOCATE(" << name_tmp << "(SIZE(" << name << "_,1), SIZE(" << name << "_,2), SIZE(" << name << "_,3), SIZE(" << name << "_,4), SIZE(" << name << "_,5)))" << iendl; \
+      oss << "  ALLOCATE(" << name_tmp << "(SIZE(" << name << "_,1), SIZE(" << name << "_,2), SIZE(" << name << "_,3), &" << iendl; \
+      oss << " SIZE(" << name << "_,4), SIZE(" << name << "_,5)))" << iendl; \
       oss << "  " << name_tmp << " = " << name << "_" << iendl; \
-      oss << "  CALL cxios_set_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
+      oss << "  CALL cxios_set_" << className << "_" << name << " &" << iendl; \
+      oss << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
     } \
-    else oss << "  CALL cxios_set_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; \
+    else { oss << "  CALL cxios_set_" << className << "_" << name << " &" << iendl; \
+           oss << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; } \
     oss << "ENDIF"; \
   }\
@@ -891,9 +910,12 @@
     if (!matchingTypeCFortran<T>())  \
     { \
-      oss << "  ALLOCATE(" << name_tmp << "(SIZE(" << name << "_,1), SIZE(" << name << "_,2), SIZE(" << name << "_,3), SIZE(" << name << "_,4), SIZE(" << name << "_,5), SIZE(" << name << "_,6)))" << iendl; \
+      oss << "  ALLOCATE(" << name_tmp << "(SIZE(" << name << "_,1), SIZE(" << name << "_,2), SIZE(" << name << "_,3), &" << iendl; \
+      oss << " SIZE(" << name << "_,4), SIZE(" << name << "_,5), SIZE(" << name << "_,6)))" << iendl; \
       oss << "  " << name_tmp << " = " << name << "_" << iendl; \
-      oss << "  CALL cxios_set_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
+      oss << "  CALL cxios_set_" << className << "_" << name << " &" << iendl; \
+      oss << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
     } \
-    else oss << "  CALL cxios_set_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; \
+    else { oss << "  CALL cxios_set_" << className << "_" << name << " &" << iendl; \
+           oss << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; } \
     oss << "ENDIF"; \
   }\
@@ -907,9 +929,13 @@
     if (!matchingTypeCFortran<T>())  \
     { \
-      oss << "  ALLOCATE(" << name_tmp << "(SIZE(" << name << "_,1), SIZE(" << name << "_,2), SIZE(" << name << "_,3), SIZE(" << name << "_,4), SIZE(" << name << "_,5), SIZE(" << name << "_,6), SIZE(" << name << "_,7)))" << iendl; \
+      oss << "  ALLOCATE(" << name_tmp << "(SIZE(" << name << "_,1), SIZE(" << name << "_,2), SIZE(" << name << "_,3), &" << iendl; \
+      oss << " SIZE(" << name << "_,4), SIZE(" << name << "_,5), SIZE(" << name << "_,6), &" << iendl; \
+      oss << " SIZE(" << name << "_,7)))" << iendl; \
       oss << "  " << name_tmp << " = " << name << "_" << iendl; \
-      oss << "  CALL cxios_set_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
+      oss << "  CALL cxios_set_" << className << "_" << name << " &" << iendl; \
+      oss << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
     } \
-    else oss << "  CALL cxios_set_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; \
+    else { oss << "  CALL cxios_set_" << className << "_" << name << " &" << iendl; \
+           oss << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; } \
     oss << "ENDIF"; \
   }
@@ -931,8 +957,10 @@
     { \
       oss << "  ALLOCATE(" << name_tmp << "(SIZE(" << name << "_,1)))" << iendl; \
-      oss << "  CALL cxios_get_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
+      oss << "  CALL cxios_get_" << className << "_" << name << " &" << iendl; \
+      oss << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
       oss << "  " << name << "_ = " << name_tmp << iendl; \
     } \
-    else oss << "  CALL cxios_get_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; \
+    else { oss << "  CALL cxios_get_" << className << "_" << name << " &" << iendl; \
+           oss << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; } \
     oss << "ENDIF"; \
   } \
@@ -947,8 +975,10 @@
     { \
       oss << "  ALLOCATE(" << name_tmp << "(SIZE(" << name << "_,1), SIZE(" << name << "_,2)))" << iendl; \
-      oss << "  CALL cxios_get_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
+      oss << "  CALL cxios_get_" << className << "_" << name << " &" << iendl; \
+      oss << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
       oss << "  " << name << "_ = " << name_tmp << iendl; \
     } \
-    else oss << "  CALL cxios_get_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; \
+    else { oss << "  CALL cxios_get_" << className << "_" << name << " &" << iendl; \
+           oss << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; } \
     oss << "ENDIF"; \
   } \
@@ -963,8 +993,10 @@
     { \
       oss << "  ALLOCATE(" << name_tmp << "(SIZE(" << name << "_,1), SIZE(" << name << "_,2), SIZE(" << name << "_,3)))" << iendl; \
-      oss << "  CALL cxios_get_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
+      oss << "  CALL cxios_get_" << className << "_" << name << " &" << iendl; \
+      oss << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
       oss << "  " << name << "_ = " << name_tmp << iendl; \
       } \
-    else oss << "  CALL cxios_get_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; \
+    else { oss << "  CALL cxios_get_" << className << "_" << name << " &" << iendl; \
+           oss << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; } \
     oss << "ENDIF"; \
   } \
@@ -978,9 +1010,12 @@
     if (!matchingTypeCFortran<T>())  \
     { \
-      oss << "  ALLOCATE(" << name_tmp << "(SIZE(" << name << "_,1), SIZE(" << name << "_,2), SIZE(" << name << "_,3), SIZE(" << name << "_,4)))" << iendl; \
-      oss << "  CALL cxios_get_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
+      oss << "  ALLOCATE(" << name_tmp << "(SIZE(" << name << "_,1), SIZE(" << name << "_,2), SIZE(" << name << "_,3), &" << iendl; \
+      oss << " SIZE(" << name << "_,4)))" << iendl; \
+      oss << "  CALL cxios_get_" << className << "_" << name << " &" << iendl; \
+      oss << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
       oss << "  " << name << "_ = " << name_tmp << iendl; \
       } \
-    else oss << "  CALL cxios_get_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; \
+    else { oss << "  CALL cxios_get_" << className << "_" << name << " &" << iendl; \
+           oss << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; }\
     oss << "ENDIF"; \
   } \
@@ -994,9 +1029,12 @@
     if (!matchingTypeCFortran<T>())  \
     { \
-      oss << "  ALLOCATE(" << name_tmp << "(SIZE(" << name << "_,1), SIZE(" << name << "_,2), SIZE(" << name << "_,3), SIZE(" << name << "_,4), SIZE(" << name << "_,5)))" << iendl; \
-      oss << "  CALL cxios_get_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
+      oss << "  ALLOCATE(" << name_tmp << "(SIZE(" << name << "_,1), SIZE(" << name << "_,2), SIZE(" << name << "_,3), &" << iendl; \
+      oss << " SIZE(" << name << "_,4), SIZE(" << name << "_,5)))" << iendl; \
+      oss << "  CALL cxios_get_" << className << "_" << name << " &" << iendl; \
+      oss << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
       oss << "  " << name << "_ = " << name_tmp << iendl; \
       } \
-    else oss << "  CALL cxios_get_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; \
+    else { oss << "  CALL cxios_get_" << className << "_" << name << " &" << iendl; \
+           oss << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; } \
     oss << "ENDIF"; \
   }\
@@ -1010,9 +1048,12 @@
     if (!matchingTypeCFortran<T>())  \
     { \
-      oss << "  ALLOCATE(" << name_tmp << "(SIZE(" << name << "_,1), SIZE(" << name << "_,2), SIZE(" << name << "_,3), SIZE(" << name << "_,4), SIZE(" << name << "_,5), SIZE(" << name << "_,6)))" << iendl; \
-      oss << "  CALL cxios_get_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
+      oss << "  ALLOCATE(" << name_tmp << "(SIZE(" << name << "_,1), SIZE(" << name << "_,2), SIZE(" << name << "_,3), &" << iendl; \
+      oss << " SIZE(" << name << "_,4), SIZE(" << name << "_,5), SIZE(" << name << "_,6)))" << iendl; \
+      oss << "  CALL cxios_get_" << className << "_" << name << " &" << iendl; \
+      oss << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
       oss << "  " << name << "_ = " << name_tmp << iendl; \
       } \
-    else oss << "  CALL cxios_get_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; \
+    else { oss << "  CALL cxios_get_" << className << "_" << name << " &" << iendl; \
+           oss << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; } \
     oss << "ENDIF"; \
   } \
@@ -1026,9 +1067,13 @@
     if (!matchingTypeCFortran<T>())  \
     { \
-      oss << "  ALLOCATE(" << name_tmp << "(SIZE(" << name << "_,1), SIZE(" << name << "_,2), SIZE(" << name << "_,3), SIZE(" << name << "_,4), SIZE(" << name << "_,5), SIZE(" << name << "_,6), SIZE(" << name << "_,7)))" << iendl; \
-      oss << "  CALL cxios_get_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
+      oss << "  ALLOCATE(" << name_tmp << "(SIZE(" << name << "_,1), SIZE(" << name << "_,2), SIZE(" << name << "_,3), &" << iendl; \
+      oss << " SIZE(" << name << "_,4), SIZE(" << name << "_,5), SIZE(" << name << "_,6), &" << iendl; \
+      oss << " SIZE(" << name << "_,7)))" << iendl; \
+      oss << "  CALL cxios_get_" << className << "_" << name << " &" << iendl; \
+      oss << "(" << className << "_hdl%daddr, " << name_tmp << ", SHAPE(" << name << "_))" << iendl; \
       oss << "  " << name << "_ = " << name_tmp << iendl; \
       } \
-    else oss << "  CALL cxios_get_" << className << "_" << name << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; \
+    else { oss << "  CALL cxios_get_" << className << "_" << name << " &" << iendl; \
+           oss << "(" << className << "_hdl%daddr, " << name << "_, SHAPE(" << name << "_))" << iendl; } \
     oss << "ENDIF"; \
   }
